There are a number of spherical balloons spread in two-dimensional space. For each balloon, provided input is the start and end coordinates of the horizontal diameter. Since it's horizontal, y-coordinates don't matter and hence the x-coordinates of start and end of the diameter suffice. Start is always smaller than end. There will be at most 104 balloons.
An arrow can be shot up exactly vertically from different points along the x-axis. A balloon with xstart and xend bursts by an arrow shot at x if xstart ≤ x ≤ xend. There is no limit to the number of arrows that can be shot. An arrow once shot keeps travelling up infinitely. The problem is to find the minimum number of arrows that must be shot to burst all balloons.
Example:
Input:
[[10,16], [2,8], [1,6], [7,12]]
Output:
2
Explanation:
One way is to shoot one arrow for example at x = 6 (bursting the balloons [2,8] and [1,6]) and another arrow at x = 11 (bursting the other two balloons).
先根據end排序,再利用greedy method。
// Greedy Method (sort based on ending position)
int findMinArrowShots(vector<vector<int> >& points) { // time: O(nlogn); space: O(1)
if (points.empty()) return 0;
// Sort by ending location
sort(points.begin(), points.end(), [] (vector<int>& a, vector<int>& b) {
return a[1] < b[1];
});
int arrowPos = points[0][1], res = 1;
for (int i = 1; i < points.size(); ++i) {
if (arrowPos >= points[i][0]) continue;
arrowPos = points[i][1];
++res;
}
return res;
}
先根據start排序,再利用greedy algorithm。
// Greedy Method (sort based on starting position)
int findMinArrowShots(vector<vector<int> >& points) { // time: O(nlogn); space: O(1)
if (points.empty()) return 0;
sort(points.begin(), points.end()); // sort by start location
int arrowPos = points[0][1], res = 1;
for (int i = 1; i < points.size(); ++i) {
if (points[i][0] > arrowPos) {
arrowPos = points[i][1];
++res;
} else {
arrowPos = min(arrowPos, points[i][1]);
}
}
return res;
}